Package: here
Title: A Simpler Way to Find Your Files
Version: 1.0.2
Date: 2025-09-06
Authors@R: 
    c(person(given = "Kirill",
             family = "M\u00fcller",
             role = c("aut", "cre"),
             email = "kirill@cynkra.com",
             comment = c(ORCID = "0000-0002-1416-3412")),
      person(given = "Jennifer",
             family = "Bryan",
             role = "ctb",
             email = "jenny@rstudio.com",
             comment = c(ORCID = "0000-0002-6983-2759")))
Description: Constructs paths to your project's files.
    Declare the relative path of a file within your project with 'i_am()'.
    Use the 'here()' function as a drop-in replacement for 'file.path()',
    it will always locate the files relative to your project root.
License: MIT + file LICENSE
URL: https://here.r-lib.org/, https://github.com/r-lib/here
BugReports: https://github.com/r-lib/here/issues
Imports: rprojroot (>= 2.1.0)
Suggests: conflicted, covr, fs, knitr, palmerpenguins, plyr, readr,
        rlang, rmarkdown, testthat, uuid, withr
VignetteBuilder: knitr
Encoding: UTF-8
RoxygenNote: 7.3.3.9000
Config/testthat/edition: 3
Config/Needs/website: tidyverse/tidytemplate
NeedsCompilation: no
Packaged: 2025-09-14 18:48:53 UTC; kirill
Author: Kirill Müller [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1416-3412>),
  Jennifer Bryan [ctb] (ORCID: <https://orcid.org/0000-0002-6983-2759>)
Maintainer: Kirill Müller <kirill@cynkra.com>
Repository: CRAN
Date/Publication: 2025-09-15 05:10:09 UTC
Built: R 4.6.0; ; 2026-04-25 15:50:06 UTC; unix

here

this module replaces a call to C< use here LIST; > with the contents of
C< LIST > at compile time.  perl then compiles C< LIST > and the remaining code.
there is not an implicit block around C< LIST >

an example is probably best:

    my $x;
    use here 'my $y';
    my $z;

is exactly equivalent to:

    my $x;
    my $y;
    my $z;

the important thing here is that C< $y > is still in scope, which would not be
the case with a runtime C< eval >:

    my $x;
    eval 'my $y';
    my $z; # $y is not in scope here!


INSTALLATION

To install this module, run the following commands:

	perl Build.PL
	./Build
	./Build test
	./Build install

SUPPORT AND DOCUMENTATION

After installing, you can find documentation for this module with the
perldoc command.

    perldoc here

You can also look for information at:

    RT, CPAN's request tracker
        http://rt.cpan.org/NoAuth/Bugs.html?Dist=here

    AnnoCPAN, Annotated CPAN documentation
        http://annocpan.org/dist/here

    CPAN Ratings
        http://cpanratings.perl.org/d/here

    Search CPAN
        http://search.cpan.org/dist/here/


LICENSE AND COPYRIGHT

Copyright (C) 2011 Eric Strom

This program is free software; you can redistribute it and/or modify it
under the terms of either: the GNU General Public License as published
by the Free Software Foundation; or the Artistic License.

See http://dev.perl.org/licenses/ for more information.

<!-- README.md and index.md are generated from README.Rmd. Please edit that file. -->

# here

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html)
[![rcc](https://github.com/r-lib/here/workflows/rcc/badge.svg)](https://github.com/r-lib/here/actions)
[![CRAN
status](https://www.r-pkg.org/badges/version/here)](https://CRAN.R-project.org/package=here)
[![Codecov test
coverage](https://codecov.io/gh/r-lib/here/branch/main/graph/badge.svg)](https://app.codecov.io/gh/r-lib/here?branch=main)
<!-- badges: end -->

The goal of the here package is to enable easy file referencing in
[project-oriented workflows](https://rstats.wtf/projects.html). In
contrast to using `setwd()`, which is fragile and dependent on the way
you organize your files, here uses the top-level directory of a project
to easily build paths to files.

## Installation

Install the released version of here from CRAN:

``` r
install.packages("here")
```

## Usage

The here package creates paths relative to the top-level directory. The
package displays the top-level of the current project on load or any
time you call `here()`:

``` r
here::i_am("README.Rmd")
#> here() starts at /Users/kirill/git/R/r-lib/here
here()
#> [1] "/Users/kirill/git/R/r-lib/here"
```

You can build a path relative to the top-level directory in order to
read or write a file:

``` r
here("inst", "demo-project", "data", "penguins.csv")
#> [1] "/Users/kirill/git/R/r-lib/here/inst/demo-project/data/penguins.csv"
readr::write_csv(palmerpenguins::penguins, here("inst", "demo-project", "data", "penguins.csv"))
```

These relative paths work regardless of where the associated source file
lives inside your project, like analysis projects with data and reports
in different subdirectories. See the included [demo
project](https://github.com/r-lib/here/tree/main/inst/demo-project) for
an example.

![](https://raw.githubusercontent.com/allisonhorst/stats-illustrations/master/rstats-artwork/here.png)
*Illustration by [Allison Horst](https://github.com/allisonhorst)*

------------------------------------------------------------------------

## Code of Conduct

Please note that the here project is released with a [Contributor Code
of Conduct](https://here.r-lib.org/CODE_OF_CONDUCT.html). By
contributing to this project, you agree to abide by its terms.

# nocov start
#' @import rprojroot
.onLoad <- function(libname, pkgname) {
  set_root_crit(is_here | is_rstudio_project | is_vscode_project | is_quarto_project | is_renv_project | is_r_package | is_remake_project | is_projectile_project | is_vcs_root)
  do_refresh_here(".")
}
# nocov end

.onAttach <- function(libname, pkgname) {
  if (!isTRUE(.root_env$root$i_am)) {
    packageStartupMessage(format_dr_here(show_reason = FALSE))
  }
}

#' Situation report
#'
#' `dr_here()` shows a message that by default also includes the
#' reason why `here()` is set to a particular directory.
#' Use this function if `here()` gives unexpected results.
#' @param show_reason `[logical(1)]`\cr
#'   Include reason in output of `dr_here()`, defaults to `TRUE`.
#' @export
#' @examples
#' dr_here()
dr_here <- function(show_reason = TRUE) {
  message(format_dr_here(show_reason = show_reason))
}

format_dr_here <- function(show_reason) {
  paste0(
    "here() starts at ", here(),
    if (show_reason) {
      paste0(
        ".",
        "\n- This directory ", format_reason(),
        "\n- Initial working directory: ", .root_env$root$wd,
        "\n- Current working directory: ", getwd(),
        NULL
      )
    }
  )
}

format_reason <- function() {
  root <- .root_env$root$f()
  if (any(vapply(.root_env$root$crit$testfun, function(f) f(root), logical(1L)))) {
    get_root_desc(.root_env$root$crit, .root_env$root$f())
  } else {
    paste0(
      "and its parents do not satisfy any of the following criteria:\n",
      format_root_criteria_items(indent = 2), "\n",
      "! Call `here::i_am()` in your scripts and reports, or use `set_here()` to create a `.here` file"
    )
  }
}

local_project()

test_that("dr_here() shows message", {
  expect_message(dr_here(), "starts at")
})

test_that("format_dr_here(show_reason = TRUE)", {
  dr <- format_dr_here(show_reason = TRUE)
  dr <- gsub(here(), "<project root>", dr, fixed = TRUE)
  dr <- gsub(getwd(), "<working directory>", dr, fixed = TRUE)
  expect_snapshot(writeLines(dr))
})

test_that("format_dr_here(show_reason = FALSE)", {
  dr <- format_dr_here(show_reason = FALSE)
  dr <- gsub(here(), "<project root>", dr, fixed = TRUE)
  expect_snapshot(writeLines(dr))
})

test_that("format_dr_here() without root", {
  local_here(tempdir())

  dr <- format_dr_here(show_reason = TRUE)
  dr <- gsub(here(), "<project root>", dr, fixed = TRUE)
  dr <- gsub(getwd(), "<working directory>", dr, fixed = TRUE)
  expect_snapshot(writeLines(dr))
})

#' Declare location of current script or report
#'
#' Add a call to `here::i_am("<project-relative path>.<ext>")`
#' at the top of your R script or in the first chunk of your rmarkdown document.
#' This ensures that the project root is set up correctly:
#' subsequent calls to `here()` will refer to the implied project root.
#' If the current working directory is outside of the project
#' where the script or report is intended to run, it will fail
#' with a descriptive message.
#'
#' Relying on the project root determined with a project file,
#' the default for versions prior to 1.0.0,
#' only weakly protects against running a script from an arbitrary directory
#' outside the intended project.
#' The `i_am()` function offers a stronger way to define the project root:
#' it will ensure that the project root actually contains a file in that location,
#' optionally checking for file contents that uniquely identify the file
#' via the `nonce` argument.
#'
#' This function will fail if the script or report is moved within the project.
#' Update the `i_am()` call to reflect the new location.
#' If you use the `nonce` argument for extra safety, be sure to change it
#' when you save an existing script or report under a new name.
#'
#' @param path `[character(1)]`\cr
#'   The path to the current script or report, relative to the project root.
#'   Passing an absolute path raises an error.
#' @param ... Must be empty, reserved for future use.
#' @param uuid `[character(1)]`\cr
#'   `r lifecycle::badge("experimental")`
#'
#'   If not `NULL`, a unique string that is matched
#'   against the first 100 lines of the file.
#'   Use [uuid::UUIDgenerate()] to create a unique string
#'   that can be used as a `uuid` argument.
#'
#' @return This function is called for its side effects.
#' @export
#' @examples
#' \dontrun{
#' here::i_am("prepare/penguins.R")
#' here::i_am("analysis/report.Rmd", uuid = "f9e884084b84794d762a535f3facec85")
#' }
i_am <- function(path, ..., uuid = NULL) {
  stopifnot(length(list(...)) == 0)

  criterion <- has_file(path, contents = uuid, n = 100, fixed = TRUE)
  tryCatch(
    root_fun <- criterion$make_fix_file(),
    error = function(e) {
      stop(
        "Could not find associated project in working directory or any parent directory.\n",
        "- Path in project: ", path, "\n",
        if (!is.null(uuid)) {
          paste0("- File must contain: ", uuid, "\n")
        },
        "- Current working directory: ", mockable_getwd(), "\n",
        "Please open the project associated with this file and try again.",
        call. = FALSE
      )
    }
  )

  set_root_crit(criterion)
  set_fix_fun(root_fun, i_am = TRUE)
  dr_here(show_reason = FALSE)
  invisible()
}

mockable_getwd <- function() {
  if (identical(Sys.getenv("TESTTHAT"), "true")) {
    "<working directory>"
  } else {
    getwd()
  }
}

#' Add a marker file to a project
#'
#' `r lifecycle::badge("superseded")`
#'
#' `set_here()` creates an empty file named `.here`, by default
#' in the current directory.
#' When here encounters such a file, it uses the
#' directory that contains this file as root.
#' This is useful if none of the default criteria apply.
#' You need to restart the R session so that `here()`
#' picks up the newly created file.
#'
#' @section Life cycle:
#' `set_here()` should no longer be necessary
#' if all scripts and reports in a project call [here::i_am()],
#' which is now the recommended workflow for declaring the project root.
#'
#' @keywords internal
#'
#' @param path `[character(1)]`\cr
#'   Directory where to create `.here` file, defaults to the current directory.
#' @param verbose `[logical(1)]`\cr
#'   Verbose output, defaults to `TRUE`.
#' @export
set_here <- function(path = ".", verbose = TRUE) {
  path <- normalizePath(path)
  file_path <- file.path(path, ".here")

  if (file.exists(file_path)) {
    if (verbose) {
      message("File .here already exists in ", path)
    }
  } else {
    writeLines(character(), file_path)
    if (verbose) {
      message(
        "Created file .here in ", path, " . ",
        "Please start a new R session in the new project directory."
      )
    }
  }

  invisible(file_path)
}

is_here <- has_file(".here")

test_that("set_here() creates file", {
  local_project()

  expect_message(set_here(path = here()), "[Cc]reated file")
  expect_true(file.exists(here(".here")))
  expect_message(set_here(path = here()), "already exists")
})

# nocov start
format_root_section <- function() {
  paste(
    "\\section{Project root}{",
    "The project root is established with a call to `here::`[here::i_am()].",
    "Although not recommended, it can be changed by calling `here::i_am()` again.",
    "",
    "In the absence of such a call (e.g. for a new project),",
    "starting with the current working directory during package load time,",
    "the directory hierarchy is walked upwards ",
    "until a directory with at least one of the following conditions is found:",
    format_root_criteria_items(),
    "",
    "In either case, `here()` appends its arguments as path components ",
    "to the root directory.",
    "}",
    sep = "\n"
  )
}
# nocov end

format_root_criteria_items <- function(indent = 0) {
  format <- format(.root_env$root$crit)[-1L]
  format <- gsub("'([^']+)'", "`\\1`", format)
  format <- paste0(strrep(" ", indent), format)
  paste(format, collapse = "\n")
}

expect_snapshot_with_error <- function(code) {
  code <- rlang::enexpr(code)

  if (packageVersion("testthat") > "3.0.0") {
    rlang::eval_tidy(rlang::quo(expect_snapshot(!!code, error = TRUE)))
  } else {
    rlang::eval_tidy(rlang::quo(expect_snapshot(!!code)))
  }
}

#' Find your files
#'
#' `here()` uses reasonable heuristics to find your project's files, based on
#' the current working directory at the time when the package is loaded.
#' Use it as a drop-in replacement for [file.path()], it will always locate the
#' files relative to your project root.
#'
#' This package is intended for interactive use only.
#' Use [rprojroot::has_file()] or the other functions in
#' the \pkg{rprojroot} package for more control,
#' or for package development.
#'
#' If `here()` raises an error or otherwise behaves unexpectedly,
#' you may have attached \pkg{plyr} or another package
#' after \pkg{here}.
#' Correct this using
#' [the \pkg{conflicted} package](https://conflicted.r-lib.org/),
#' or use `here::here("data", "df.rda")`.
#'
#' @evalRd roxygen2:::markdown(format_root_section())
#'
#' @param ... `[character]`\cr
#'   Path components below the project root, can be empty.
#'   Each argument should be a string containing one or more
#'   path components separated by a forward slash `"/"`.
#' @export
#' @examples
#' here()
#' \dontrun{
#' here("some", "path", "below", "your", "project", "root.txt")
#' here("some/path/below/your/project/root.txt")
#' }
here <- function(...) {
  .root_env$root$f(...)
}

.root_env <- new.env(parent = emptyenv())

set_root_crit <- function(criterion) {
  .root_env$root$crit <- criterion
}

do_refresh_here <- function(path) {
  tryCatch(
    set_fix_fun(.root_env$root$crit$make_fix_file(path = path), i_am = FALSE),
    error = function(e) {
      set_fix_fun(from_wd$make_fix_file(path = path), i_am = FALSE)
    }
  )
}

set_fix_fun <- function(f, i_am) {
  force(f)
  force(i_am)
  .root_env$root$f <- f
  .root_env$root$wd <- getwd()
  .root_env$root$i_am <- i_am
}

local_project <- function(..., .env = parent.frame()) {
  skip_if_not_installed("withr")

  path <- tempfile()
  dir.create(path)

  demo_path <- system.file("demo-project", package = "here")
  demo_files <- dir(demo_path, full.names = TRUE)
  file.copy(demo_files, path, recursive = TRUE)

  local_here(path, .env = .env)

  withr::defer(unlink(path, recursive = TRUE), .env)
  path
}

local_here <- function(path, ..., .env = parent.frame()) {
  old_root <- .root_env
  do_refresh_here(path)
  withr::defer(.root_env$root <- old_root, envir = .env)
  invisible()
}

local_project()

test_that("i_am() sets the project root", {
  # To reset later on
  local_here(here())
  withr::local_dir(here())

  expect_message(
    here::i_am("prepare/penguins.R", uuid = "115147ca-fedd-42ca-8650-2cb3dad0aebc"),
    "starts at"
  )

  dr <- format_dr_here(show_reason = TRUE)
  dr <- gsub(here(), "<project root>", dr, fixed = TRUE)
  expect_snapshot(writeLines(dr))
})

test_that("i_am() fails with useful message", {
  # To reset later on
  local_here(here())
  withr::local_dir(tempdir())

  expect_snapshot_with_error(
    here::i_am("prepare/penguins.R", uuid = "115147ca-fedd-42ca-8650-2cb3dad0aebc")
  )
})

---
title: "Using here with rmarkdown"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Using here with rmarkdown}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  error = !identical(Sys.getenv("IN_PKGDOWN"), "true")
)

project_path <- system.file("demo-project", package = "here")
```

The here package enables easy file referencing by using the top-level directory of a file project to easily build file paths.
This article demonstrates the case where the working directory is set to a subdirectory of the project root, for instance when rendering an R Markdown document that lives in a subdirectory.
See `vignette("here")` for a more general introduction.

## rmarkdown starts in a subdirectory

For demonstration, this article uses a data analysis project that lives in `` `r project_path` `` on my machine.
This is the *project root*.
The path will most likely be different on your machine, the here package helps deal with this situation.

The project has the following structure:

```{r echo = FALSE}
fs::dir_tree(project_path)
```

When `report.Rmd` is rendered, the working directory is internally set to `<project root>/analysis` by rmarkdown:

```{r eval = FALSE}
setwd(file.path(project_path, "analysis"))
```

```{r include = FALSE}
knitr::opts_knit$set(root.dir = file.path(project_path, "analysis"))
```

```{r}
getwd()
```

However, `penguins.csv` still lives in the `data/` subdirectory.
The report requires the `penguins.csv` file to work.

## here always uses project-relative paths

To render `report.Rmd`, you would have to ensure the path to `penguins.csv` is relative to the `analysis/` directory - i.e., `../data/penguins.csv`. The chunks would knit properly, but could not be run in the console since the working directory in the console *isn't* `analysis/`.

The here package circumvents this issue by always referring to the project root:

```{r}
here::i_am("analysis/report.Rmd")
```

All files accessed by `report.Rmd` should be referred to using `here()`:

```{r}
library(here)
here("data", "penguins.csv")
here("data/penguins.csv")
```

This ensures that `penguins.csv` can be read both when the report is knit and when the code is run interactively in the console.

---
title: "here"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{here}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  error = !identical(Sys.getenv("IN_PKGDOWN"), "true")
)

project_path <- system.file("demo-project", package = "here")
```

The here package enables easy file referencing by using the top-level directory of a file project to easily build file paths.
This is in contrast to using `setwd()`, which is fragile and dependent on the way you order your files on your computer.
Read more about project-oriented workflows:

- What They Forgot to Teach You About R: ["Project-oriented workflow"](https://rstats.wtf/projects.html) chapter by Jenny Bryan and Jim Hester

- ["Project-oriented workflow"](https://www.tidyverse.org/blog/2017/12/workflow-vs-script/) blog post by Jenny Bryan

- R for data science: ["Workflow: projects"](https://r4ds.had.co.nz/workflow-projects.html) chapter by Hadley Wickham

## Basic functionality

For demonstration, this article uses a data analysis project that lives in `` `r project_path` `` on my machine.
This is the *project root*.
The path will most likely be different on your machine, the here package helps deal with this situation.

The project has the following structure:

```{r echo = FALSE}
fs::dir_tree(project_path)
```

You can review the project on [GitHub](https://github.com/r-lib/here/tree/main/inst/demo-project) and also download a copy.

To start working on this project in RStudio, open the `demo-project.Rproj` file.
This ensures that the [working directory](https://en.wikipedia.org/wiki/Working_directory) is set to `` `r project_path` ``, the project root.
Opening only the `.R` or the `.Rmd` file may be insufficient!

Other development environments may have a different notion of a project.
Either way, it is important that the working directory is set to the project root or a subdirectory of that path.
You can check with:

```{r eval = FALSE}
setwd(project_path)
```

```{r include = FALSE}
knitr::opts_knit$set(root.dir = project_path)
```

```{r}
getwd()
```

(See `vignette("rmarkdown")` for an example where the working directory is set to a subdirectory on start.)

### Declare the location of the current script

The intended use is to add a call to `here::i_am()` at the beginning of your script or in the first chunk of your rmarkdown report.[^legacy]
This achieves the following:

[^legacy]: Prior to version 1.0.0, it was recommended to attach the here package via `library(here)`.
This still works, but is no longer the recommended approach.

- The location of the current script or report within the project is declared
- The project root is initialized, consistent with the location of the current script or report
- An informative message is emitted.[^print]

[^print]: `library(here)` no longer emits an informative message if `here::i_am()` has been called before.

The first argument to `here::i_am()` should be the path to the current file, relative to the project root.
The `penguins.R` script uses:

```{r}
here::i_am("prepare/penguins.R")
```

`here::i_am()` displays the top-level directory of the current project.
Because the project has a `prepare/` directory in its root that contains `penguins.R`, it is correctly inferred as the project root.

After `here::i_am()`, insert `library(here)` to make the `here()` function available:[^why-not-first]

[^why-not-first]: `library(here)` emits a message that may be confusing if followed by the message from `here::i_am()`.

```{r}
library(here)
```

The top-level directory is also returned from the `here()` function:

```{r}
here()
```

One important distinction from the working directory is that this remains stable even if the working directory is changed:

```{r}
setwd("analysis")
getwd()
here()
setwd("..")
```

(I suggest to steer clear from ever changing the working directory.
This may not always be feasible, in particular if the working directory is changed by code that you do not control.)


### Use project-relative paths

You can build a path relative to the top-level directory in order to build the full path to a file:

```{r}
here("data", "penguins.csv")
readr::read_csv(
  here("data", "penguins.csv"),
  col_types = list(.default = readr::col_guess()),
  n_max = 3
)
```

This works regardless of where the associated source file lives inside your project.
With `here()`, the path will always be relative to the top-level project directory.

`here()` works very similarly to `file.path()` or `fs::path()`, you can pass path components or entire subpaths:

```{r}
here("data/penguins.csv")
```

As seen above, `here()` returns absolute paths (starting with `/`, `<drive letter>:\` or `\\`).
This makes it safe to pass these paths to other functions, even if the working directory is changed along the way.

As of version 1.0.0, absolute paths passed to `here()` are returned unchanged.
This means that you can safely use both absolute and project-relative paths in `here()`.

```{r}
data_path <- here("data")
here(data_path)
here(data_path, "penguins.csv")
```


### Situation report

The `dr_here()` function explains the reasoning behind choosing the project root:

```{r}
dr_here()
```

The `show_reason` argument can be set to `FALSE` to reduce the output to one line:

```{r}
dr_here(show_reason = FALSE)
```


### What if the working directory is wrong?

The declaration of the active file via `here::i_am()` also protects against accidentally running the script from a working directory outside of your project.
The example below calls `here::i_am()` from the temporary directory, which is clearly outside our project:

```{r error = TRUE}
withr::with_dir(tempdir(), {
  print(getwd())
  here::i_am("prepare/penguins.R")
})
```

This can also happen when a file has been renamed or moved without updating the `here::i_am()` call.
In the future, a helper function will assist with installing and updating suitably formatted `here::i_am()` calls in your scripts and reports.


## Extra safety

### Conflicts with other packages

Other packages also export a `here()` function.
Loading these packages after loading here masks our `here()` function:

```{r error = TRUE}
library(plyr)
here()
```

One way to work around this problem is to use `here::here()`:

```{r}
here::here()
```

The conflicted package offers an alternative: it detects that `here()` is exported from more than one package and allows you to use neither until you indicate a preference.

```{r error = TRUE}
library(conflicted)
here()

conflicted::conflict_prefer("here", "here")
here()
```


### Specify a unique identifier

To eliminate potential confusion, `here::i_am()` accepts a `uuid` argument.
The idea is that each script and report calls `here::i_am()` very early (in the first 100 lines) with a universally unique identifier.
Even if a file location is reused across projects (e.g. two projects contain a "prepare/data.R" file), the files can be identified correctly if the `uuid` argument in the `here::i_am()` call is different.

If a `uuid` argument is passed to `here::i_am()`:

- a project root that contains a file at the specified file path is searched
- the first 100 lines of that file are read
- for the correct file, the `here::i_am()` call that passes this very `uuid` is among those 100 lines, and will be matched
- for the wrong file, `uuid` is not found in the text

Use `uuid::UUIDgenerate()` to create universally unique identifiers:

```{r}
uuid::UUIDgenerate()
```

Ensure that the `uuid` arguments are actually unique across your files!
In the future, a helper function will assist with installing and updating suitably formatted `here::i_am()` calls in your scripts and reports.


## Beyond here

### Change project root

It is advisable to [start a fresh R session](https://rstats.wtf/source-and-blank-slates) as often as possible, especially before focusing on another project.
There still may be legitimate cases when it is desirable to reset the project root.

To start, let's create a temporary project for demonstration:

```{r}
temp_project_path <- tempfile()
dir.create(temp_project_path)
scripts_path <- file.path(temp_project_path, "scripts")
dir.create(scripts_path)
script_path <- file.path(scripts_path, "script.R")
writeLines(
  c(
    'here::i_am("scripts/script.R")',
    'print("Hello, world!")'
  ),
  script_path
)
fs::dir_tree(temp_project_path)
writeLines(readLines(script_path))
```

The `script.R` file contains a call to `here::i_am()` to declare its location.
Running it from the current working directory will fail:

```{r error = TRUE}
source(script_path, echo = TRUE)
```

To reset the project root mid-session, change the working directory with `setwd()`.
Now, the subsequent call to `here::i_am()` from within `script.R` works:

```{r eval = FALSE}
setwd(temp_project_path)
```

```{r include = FALSE}
knitr::opts_knit$set(root.dir = temp_project_path)
```

```{r}
source(script_path, echo = TRUE)
```

To reiterate: a fresh session is almost always the better, cleaner, safer, and more robust solution.
Use this approach only as a last resort.


### Under the hood: rprojroot

The here package has a very simple and restricted interface, by design.
The underlying logic is provided by the much more powerful rprojroot package.
If the default behavior of here does not suit your workflow for one reason or another, the rprojroot package may be a better alternative.
It is also recommended to import rprojroot and not here from other packages.

The following example shows how to find an RStudio project starting from a directory:

```{r}
library(rprojroot)
find_root(is_rstudio_project, file.path(project_path, "analysis"))
```

Arbitrary criteria can be defined.
See `vignette("rprojroot", package = "rprojroot")` for an introduction.

---
title: "Palmer penguins"
author: "Kirill Müller"
date: "11/12/2020"
output: html_document
---

```{r setup, include=FALSE}
here::i_am("analysis/report.Rmd", uuid = "50208352-4ee9-4401-bb40-9f7ec81050da")
library(here)

knitr::opts_chunk$set(echo = TRUE)

penguins <- readr::read_csv(here("data/penguins.csv"))
```

## Linear model

```{r}
lm(flipper_length_mm ~ body_mass_g + species, penguins)
```

# i_am() sets the project root

    Code
      writeLines(dr)
    Output
      here() starts at <project root>.
      - This directory contains a file 'prepare/penguins.R' with contents '115147ca-fedd-42ca-8650-2cb3dad0aebc' in the first 100 lines
      - Initial working directory: <project root>
      - Current working directory: <project root>

# i_am() fails with useful message

    Code
      here::i_am("prepare/penguins.R", uuid = "115147ca-fedd-42ca-8650-2cb3dad0aebc")
    Condition
      Error:
      ! Could not find associated project in working directory or any parent directory.
      - Path in project: prepare/penguins.R
      - File must contain: 115147ca-fedd-42ca-8650-2cb3dad0aebc
      - Current working directory: <working directory>
      Please open the project associated with this file and try again.

# format_dr_here(show_reason = TRUE)

    Code
      writeLines(dr)
    Output
      here() starts at <project root>.
      - This directory contains a file matching '[.]Rproj$' with contents matching '^Version: ' in the first line
      - Initial working directory: <working directory>
      - Current working directory: <working directory>

# format_dr_here(show_reason = FALSE)

    Code
      writeLines(dr)
    Output
      here() starts at <project root>

# format_dr_here() without root

    Code
      writeLines(dr)
    Output
      here() starts at <project root>.
      - This directory and its parents do not satisfy any of the following criteria:
        - contains a file `.here`
        - contains a file matching `[.]Rproj$` with contents matching `^Version: ` in the first line
        - contains a file `.vscode/settings.json`
        - contains a file `_quarto.yml`
        - contains a file `renv.lock` with contents matching `"Packages":\s*\{`
        - contains a file `DESCRIPTION` with contents matching `^Package: `
        - contains a file `remake.yml`
        - contains a file `.projectile`
        - contains a directory `.git`
        - contains a file `.git` with contents matching `^gitdir: `
        - contains a directory `.svn`
      ! Call `here::i_am()` in your scripts and reports, or use `set_here()` to create a `.here` file
      - Initial working directory: <working directory>
      - Current working directory: <working directory>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/set_here.R
\name{set_here}
\alias{set_here}
\title{Add a marker file to a project}
\usage{
set_here(path = ".", verbose = TRUE)
}
\arguments{
\item{path}{\verb{[character(1)]}\cr
Directory where to create \code{.here} file, defaults to the current directory.}

\item{verbose}{\verb{[logical(1)]}\cr
Verbose output, defaults to \code{TRUE}.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#superseded}{\figure{lifecycle-superseded.svg}{options: alt='[Superseded]'}}}{\strong{[Superseded]}}
}
\details{
\code{set_here()} creates an empty file named \code{.here}, by default
in the current directory.
When here encounters such a file, it uses the
directory that contains this file as root.
This is useful if none of the default criteria apply.
You need to restart the R session so that \code{here()}
picks up the newly created file.
}
\section{Life cycle}{

\code{set_here()} should no longer be necessary
if all scripts and reports in a project call \code{\link[=i_am]{i_am()}},
which is now the recommended workflow for declaring the project root.
}

\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/here.R
\name{here}
\alias{here}
\title{Find your files}
\usage{
here(...)
}
\arguments{
\item{...}{\verb{[character]}\cr
Path components below the project root, can be empty.
Each argument should be a string containing one or more
path components separated by a forward slash \code{"/"}.}
}
\description{
\code{here()} uses reasonable heuristics to find your project's files, based on
the current working directory at the time when the package is loaded.
Use it as a drop-in replacement for \code{\link[=file.path]{file.path()}}, it will always locate the
files relative to your project root.
}
\details{
This package is intended for interactive use only.
Use \code{\link[rprojroot:root_criterion]{rprojroot::has_file()}} or the other functions in
the \pkg{rprojroot} package for more control,
or for package development.

If \code{here()} raises an error or otherwise behaves unexpectedly,
you may have attached \pkg{plyr} or another package
after \pkg{here}.
Correct this using
\href{https://conflicted.r-lib.org/}{the \pkg{conflicted} package},
or use \code{here::here("data", "df.rda")}.
}
\examples{
here()
\dontrun{
here("some", "path", "below", "your", "project", "root.txt")
here("some/path/below/your/project/root.txt")
}
}
\section{Project root}{
The project root is established with a call to \verb{here::}\code{\link[=i_am]{i_am()}}.
Although not recommended, it can be changed by calling \code{here::i_am()} again.

In the absence of such a call (e.g. for a new project),
starting with the current working directory during package load time,
the directory hierarchy is walked upwards
until a directory with at least one of the following conditions is found:
\itemize{
\item contains a file \code{.here}
\item contains a file matching \verb{[.]Rproj$} with contents matching \verb{^Version: } in the first line
\item contains a file \code{.vscode/settings.json}
\item contains a file \verb{_quarto.yml}
\item contains a file \code{renv.lock} with contents matching \verb{"Packages":\\s*\\\{}
\item contains a file \code{DESCRIPTION} with contents matching \verb{^Package: }
\item contains a file \code{remake.yml}
\item contains a file \code{.projectile}
\item contains a directory \code{.git}
\item contains a file \code{.git} with contents matching \verb{^gitdir: }
\item contains a directory \code{.svn}
}

In either case, \code{here()} appends its arguments as path components
to the root directory.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/i_am.R
\name{i_am}
\alias{i_am}
\title{Declare location of current script or report}
\usage{
i_am(path, ..., uuid = NULL)
}
\arguments{
\item{path}{\verb{[character(1)]}\cr
The path to the current script or report, relative to the project root.
Passing an absolute path raises an error.}

\item{...}{Must be empty, reserved for future use.}

\item{uuid}{\verb{[character(1)]}\cr
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

If not \code{NULL}, a unique string that is matched
against the first 100 lines of the file.
Use \code{\link[uuid:UUIDgenerate]{uuid::UUIDgenerate()}} to create a unique string
that can be used as a \code{uuid} argument.}
}
\value{
This function is called for its side effects.
}
\description{
Add a call to \code{here::i_am("<project-relative path>.<ext>")}
at the top of your R script or in the first chunk of your rmarkdown document.
This ensures that the project root is set up correctly:
subsequent calls to \code{here()} will refer to the implied project root.
If the current working directory is outside of the project
where the script or report is intended to run, it will fail
with a descriptive message.
}
\details{
Relying on the project root determined with a project file,
the default for versions prior to 1.0.0,
only weakly protects against running a script from an arbitrary directory
outside the intended project.
The \code{i_am()} function offers a stronger way to define the project root:
it will ensure that the project root actually contains a file in that location,
optionally checking for file contents that uniquely identify the file
via the \code{nonce} argument.

This function will fail if the script or report is moved within the project.
Update the \code{i_am()} call to reflect the new location.
If you use the \code{nonce} argument for extra safety, be sure to change it
when you save an existing script or report under a new name.
}
\examples{
\dontrun{
here::i_am("prepare/penguins.R")
here::i_am("analysis/report.Rmd", uuid = "f9e884084b84794d762a535f3facec85")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dr_here.R
\name{dr_here}
\alias{dr_here}
\title{Situation report}
\usage{
dr_here(show_reason = TRUE)
}
\arguments{
\item{show_reason}{\verb{[logical(1)]}\cr
Include reason in output of \code{dr_here()}, defaults to \code{TRUE}.}
}
\description{
\code{dr_here()} shows a message that by default also includes the
reason why \code{here()} is set to a particular directory.
Use this function if \code{here()} gives unexpected results.
}
\examples{
dr_here()
}
